<?php
/**
 * @package MoreVideoEmbed
 * @author Fx NION
 * @version 1.0.0
 */
/*
Plugin Name: MoreVideoEmbed
Plugin URI: http://fxnion.free.fr/#
Description: Using the 'oEmbed' style for WP 2.9.X and allow to play videos somewhere else than youtube, dailymotion, etc. FLV, MP4, MP3, AAC, JPG, PNG, GIF, SWF are supported, the url must end with the corresponding file format. Usefull for files stored somewhere in the net and that don't have oEmbed API available.
Author: Fx NION
Version: 1.0.0
Author URI: http://fxnion.free.fr/
*/
function wp_embed_handler_morevideoembed_flv( $matches, $attr, $url, $rawattr ) {
	// If the user supplied a fixed width AND height, use it
	if ( !empty($rawattr['width']) && !empty($rawattr['height']) ) {
		$width  = (int) $rawattr['width'];
		$height = (int) $rawattr['height'];
	} else {
		list( $width, $height ) = wp_expand_dimensions( 425, 344, $attr['width'], $attr['height'] );
	}
	$player_location = get_option('siteurl').'/wp-content/plugins/morevideoembed/player.swf';
	
	return apply_filters( 'morevideoembed_flv', 
						  '<embed type="application/x-shockwave-flash" src="'.
						  $player_location.'?file=' . esc_attr($url) 
						  . '" style="width:' . esc_attr($width) 
						  . 'px;height:' . esc_attr($height) 
						  . 'px" allowFullScreen="true" allowScriptAccess="always"></embed>', 
						  $matches, $attr, $url, $rawattr );
}

//FLV, MP4, MP3, AAC, JPG, PNG, GIF, SWF
wp_embed_register_handler( 'morevideoembed_flv', 
						   '#http://(.*?.flv$)#i', 
						   'wp_embed_handler_morevideoembed_flv' );
						   
wp_embed_register_handler( 'morevideoembed_mp4', 
						   '#http://(.*?.mp4$)#i', 
						   'wp_embed_handler_morevideoembed_flv' );
						   
wp_embed_register_handler( 'morevideoembed_aac', 
						   '#http://(.*?.aac$)#i', 
						   'wp_embed_handler_morevideoembed_flv' );
						   
wp_embed_register_handler( 'morevideoembed_swf', 
						   '#http://(.*?.swf$)#i', 
						   'wp_embed_handler_morevideoembed_flv' );

wp_embed_register_handler( 'morevideoembed_png', 
						   '#http://(.*?.png$)#i', 
						   'wp_embed_handler_morevideoembed_flv' );
						   
wp_embed_register_handler( 'morevideoembed_gif', 
						   '#http://(.*?.gif$)#i', 
						   'wp_embed_handler_morevideoembed_flv' );
						   
wp_embed_register_handler( 'morevideoembed_jpg', 
						   '#http://(.*?.jpg$)#i', 
						   'wp_embed_handler_morevideoembed_flv' );
						   
wp_embed_register_handler( 'morevideoembed_jpeg', 
						   '#http://(.*?.jpeg$)#i', 
						   'wp_embed_handler_morevideoembed_flv');

?>
